# Custom erorrs for dumpster truck
# Http status codes: https://en.wikipedia.org/wiki/List_of_HTTP_status_codes#4xx_Client_errors

ClientHTTPEResponses = {
    400:'Bad Request',
    401:'Unauthorized',
    402:'Payment Required',
    403:'Forbidden',
    404:'File Not Found',
    405:'Method Not Allowed',
    406:'Not Acceptable',
    407:'Proxy Authentication Required',
    408:'Request Timeout',
    410:'Gone',
    411:'Length Required',
    412:'Precondition Failed',
    413:'Payload Too large',
    414:'URI Too Long',
    415:'Unsupported Media Type',
    416:'Range Not Satisfiable',
    417:'Expectation Failed',
    418:'I\\\'m a teapot', # Believe it or not some websites use this status code
    421:'Misdirected Request',
    422:'Unprocessable Entity',
    423:'Locked',
    424:'Failed Dependency',
    425:'Too Early',
    426:'Upgrade Required',
    428:'Precondition Required',
    429:'Too many requests',
    431:'Request Header Fields Too Large',
    451:'Unavailable For Legal Reasons'
}
ServerHTTPEResponses = {
    500:'Internal Server Error',
    501:'Not Implemented',
    502:'Bad Gateway',
    503:'Service Unavailable',
    504:'Gateway Timeout',
    505:'HTTP Version Not Supported',
    506:'Variant Also Negotiates',
    507:'Insufficient Storage',
    508:'Loop Detected',
    510:'Not Extended',
    511:'Network Authentication Required'
}

class HTTPResponse(Exception):
    pass

class HTTP4xxResponse(HTTPResponse):
    pass

class HTTP5xxResponse(HTTPResponse):
    pass

for reqCode in range(100):
    if len(str(reqCode)) == 1:
        httpCode = '40'+str(reqCode)
    else:
        httpCode = '4'+str(reqCode)
    try:
        info = ClientHTTPEResponses[int(httpCode)]
    except KeyError:
        info = 'Unknown client response code'
    customErrorCode = compile('''class HTTP'''+httpCode+'''Response(HTTP4xxResponse):
    def __init__(self):
        Exception.__init__(self,\''''+info+'''\')''', 'CustomError', 'exec')
    exec(customErrorCode)

for reqCode in range(100):
    if len(str(reqCode)) == 1:
        httpCode = '50'+str(reqCode)
    else:
        httpCode = '5'+str(reqCode)
    try:
        info = ServerHTTPEResponses[int(httpCode)]
    except KeyError:
        info = 'Unknown server response code'
    customErrorCode = compile('''class HTTP'''+httpCode+'''Response(HTTP5xxResponse):
    def __init__(self):
        Exception.__init__(self,\''''+info+'''\')''', 'CustomError', 'exec')
    exec(customErrorCode)
